#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <string.h>
#include "dSFMT.h"

/*
You need to input 3 vairable
 N：the number of node
 S：the seed of random numebr
 M：the maximum value of uniform distribution
*/

int main (int argc, char *argv[]) {
	
    // variable //
	dsfmt_t dsfmt;
	int *ll,*lr, *deg, *rem;
	int i, l, r, sum, mult, ri;
	int k_sum, k_max;
	int M=1;
	int t=0;
	int t_max;
	int Line;
	double gamma;
	double u,x;
	
	int degree_min=1*atoi(argv[4]);     // 最小次数
	int degree_max=16500*atoi(argv[4]); 
	
	int N = atoi(argv[1]);
	dsfmt_init_gen_rand(&dsfmt,atoi(argv[2]));
	gamma = atof(argv[3]);
	
	N++;
	deg = (int *)calloc(N, sizeof(int));
	rem = (int *)calloc(N, sizeof(int));
	
	k_sum = 0;
    
/*--------------------逆関数法による次数列の生成--------------------*/
	for (i = 1 ; i < N ; i++) {
		
		u = dsfmt_genrand_close_open(&dsfmt);
		
		x = pow((pow(degree_min, -1.0*gamma) - pow(degree_max, -1.0*gamma))*u + pow(degree_max, -1.0*gamma), -1.0*(1.0/gamma));
		
		deg[i] = (int)x;
		
		// 次数和の計算 //
		k_sum += deg[i];
		
		// 初期残り次数の格納 //
		rem[i] = deg[i];
	
	}
/*--------------------------------------------------------------*/
    
	// 次数和が奇数の場合、最後の次数に+1 //
	if ((k_sum/2)*2 != k_sum) {
		deg[N-1] += 1;
		rem[N-1] += 1;
		k_sum += 1;
	}
	
    // 最大反復回数の設定 //
    t_max = k_sum*100;
    
	// リストの行数 //
	Line = k_sum/2;
	Line++;
    
    // リスト配列のcalloc //
	ll = (int *)calloc(Line, sizeof(int));
	lr = (int *)calloc(Line, sizeof(int));
	
	// k_sumが0より大きい、反復回数が最大反復回数を超えない限り継続 //
	while ((k_sum > 0) && (t < t_max)) {
		
		k_max = 0;
		
		// 残り次数が最大のノードをlに選ぶ //
		for (i = 1 ; i < N ; i++) {
			if (rem[i] >= k_max) {
				k_max = rem[i];
				l = i;
			}
		}
        
		ri = (int)(k_sum-k_max)*dsfmt_genrand_close_open(&dsfmt);
		sum = 0;
		int flag=0;
        // rの決定 //
		for (i = 1 ; i < N ; i++) {
			if(i!=l)
			{
			sum+=rem[i];
			if(sum>ri && flag==0)
			{
			r=i;
			flag=1;
			}
			}
		}
		
		mult = 0;
		
		if(dsfmt_genrand_close_open(&dsfmt)>0.5)
		{
		for(i=1;i<M;i++)
		{
		if ((ll[i]==l) && (lr[i]==r)) {
				mult = 1;
		}
		}
			if (mult == 0) {
			ll[M] = l;
			lr[M] = r;
			k_sum-=2;
			M++;
			rem[l] -= 1;
			rem[r] -= 1;
			}
			
		}else{
		for(i=1;i<M;i++)
		{
		if ((ll[i]==r) && (lr[i]==l)) {
				mult = 1;
		}
		}
			if (mult == 0) {
			ll[M] = r;
			lr[M] = l;
			k_sum-=2;
			M++;
			rem[l] -= 1;
			rem[r] -= 1;
			}
			
		}
		
		//printf("%f %f\n",(double)t/t_max,(double)M/Line);
		t++;
		
	}
	
	
    // 反復回数超過で失敗、そうでなければlist出力 //
	if (t == t_max) {
		M=0;
		printf("# --- Failure!! --- #\n");
	} else {
		for (i = 1 ; i < Line ; i++) {
				printf("%d %d\n",ll[i], lr[i]);
		}
	}
	
	free(deg);
	free(rem);
	free(ll);
	free(lr);
}
